about summary refs log tree commit diff
path: root/tools/bin/__dispatch.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tools/bin/__dispatch.sh')
-rwxr-xr-xtools/bin/__dispatch.sh40
1 files changed, 40 insertions, 0 deletions
diff --git a/tools/bin/__dispatch.sh b/tools/bin/__dispatch.sh
new file mode 100755
index 0000000000..fb8a4d7791
--- /dev/null
+++ b/tools/bin/__dispatch.sh
@@ -0,0 +1,40 @@
+#!/usr/bin/env bash
+# This script dispatches invocations transparently to programs instantiated from
+# Nix.
+#
+# To add a new tool, insert it into the case statement below by setting `attr`
+# to the key in nixpkgs which represents the program you want to run.
+set -ueo pipefail
+
+readonly REPO_ROOT=$(git rev-parse --show-toplevel)
+readonly TARGET_TOOL=$(basename $0)
+
+case "${TARGET_TOOL}" in
+  terraform)
+    attr="third_party.terraform-gcp"
+    ;;
+  kontemplate)
+    attr="kontemplate"
+    ;;
+  blog_cli)
+    attr="tools.blog_cli"
+    ;;
+  stern)
+    attr="stern"
+    ;;
+  pass)
+    attr="tools.kms_pass"
+    ;;
+  aoc2019)
+    attr="tools.aoc2019.${1}"
+    ;;
+  *)
+    echo "The tool '${TARGET_TOOL}' is currently not installed in this repository."
+    exit 1
+    ;;
+esac
+
+result=$(nix-build --no-out-link --attr "${attr}" "${REPO_ROOT}")
+PATH="${result}/bin:$PATH"
+
+exec "${TARGET_TOOL}" "${@}"